'
' Install script for admin mod v2.5x
' Original Copyright (C) 2000,2001 Alfred Reynolds (alfred@mazuma.net.au) 
' Adapted with permission to Version 2.5x installer by Wraith,
' 

Dim mod_name,fso,in_lib,out_lib,line,HLpath,WSHShell,answer,username,pass,Version,TSO,Str,Int,a,noread,filenamein,filenameout,GamedllFound
Const ForReading = 1, ForWriting = 2, ForAppending = 8

Version= "2.50.07"

Set fso = CreateObject("Scripting.FileSystemObject")

checkfiles

answer =msgbox("This script will install Admin Mod "&version&" for you",vbokcancel,"Starting installation")
if answer<> 1 then wscript.quit 1

answer = msgbox("This installer will now attempt to use your registry to find the location of your half-life game."&vbcrlf&" Choose OK unless you are attempting to install to a dedicated server or wish to use only relative paths for this installation."&vbcrlf&vbcrlf&"If you are installing to a dedicated server Admin Mod must be correctly unzipped to the right location for the installation to complete sucessfully. For details please read the supplied documentation before you continue.",vbOKCancel,"Allow Admin Mod Installer to read a registry key?")
if answer = 1 then
	getregkey
else
	HLpath=".."
end if

if HLpath=".." then
	if fso.fileexists(hlpath&"\hl.exe")=true then
		hlpath = fso.GetAbsolutePathName(fso.getparentfoldername(".")&"..\hl.exe")
		hlpath=left(hlpath,len(HLpath)-7)
		msgbox hlpath
	else
		if fso.fileexists(hlpath&"\HLDS.exe")=true then
			hlpath=fso.GetAbsolutePathName(fso.getparentfoldername(".")&"..\HLDS.exe")
			hlpath=left(hlpath,len(HLpath)-9)
			msgbox "Admin Mod has detected your dedicated server installation. "&vbcrlf&hlpath&vbcrlf&"This allows you only to install to the dedicated server, later when prompted you should supply server.cfg as you config filename.",vbokonly,"Dedicated server installation detected"
		end if
	end if
	if hlpath= ".." then
		hlpath=inputbox("Your Halflife or dedicated server directoy could not be found. This is most often caused by Admin Mod being unzipped into the wrong place. Please read the help guide for instructions."&vbcrlf&vbcrlf&"Please type the full path to your installation folder below and click OK. ( eg. C:\SIERRA\Halflife )","Halflife not found.")
		if fso.folderexists(hlpath)=false then
				msgbox "The installer could not find your halflife installation. This probably means you have not specifed the right location please try again and read the instructions carefully."&vbcrlf&"This installer will now exit.",vbokonly,"Exiting"
				wscript.quit
			end if
		if lcase(right(hlpath,6)) ="\hl.exe" then
			hlpath=left(hlpath,len(hlpath) -7)
			if fso.fileexists(hlpath&"\hl.exe")=false then
				msgbox "The installer could not find your halflife installation. This probably means you have not specifed the right location please try again and read the instructions carefully."&vbcrlf&"This installer will now exit.",vbokonly,"Exiting"
				wscript.quit
			end if
		else 
			if lcase(right(hlpath,9))="\hlds.exe" then 
				hlpath=left(hlpath,len(hlpath) -9)
					if fso.fileexists(hlpath&"\hlds.exe")=false then
					msgbox "The installer could not find your server installation. This probably means you have not specifed the right location please try again and read the instructions carefully."&vbcrlf&"This installer will now exit.",vbokonly,"Exiting"
					wscript.quit
				end if
			end if
		end if
	end if
end if

mod_name = inputbox("Enter the directory name of the mod you wish to install Admin Mod to (i.e cstrike, si ,tfc)","Modification choice")
gamedllFound=false
if fso.FileExists(HLpath&"\"&mod_name&"\liblist.gam")<>true then
	if mod_name="" then
		wscript.quit 1
	else
		msgbox "The installer could not find the liblist.gam file for your mod. This probably means you have not specifed a valid modification folder."&vbcrlf&"This installer will now exit.",vbokonly,"Exiting"
	wscript.quit 1
	end if
end if

if fso.FolderExists(HLpath&"\"&mod_name&"\dlls")<>true then
	msgbox "The installer was unable to find the dlls directory of the mod you specified. This installer will now exit.",vbokonly,"Exiting"
	wscript.quit 1
end if

fso.copyfile "config\*.ini" ,HLpath&"\"&mod_name&"\"
fso.copyfile "dlls\*.dll",HLpath&"\"&mod_name&"\dlls\",true
fso.copyfile "scripting\binaries\*.*",HLpath&"\"&mod_name&"\dlls",true
if fso.fileexists("config\admin_help.cfg")=true then fso.copyfile "config\admin_help.cfg", HLpath&"\"&mod_name&"\"
if fso.fileexists(HLpath&"\"&mod_name&"\AdminMod backup of liblist.gam")=false then fso.copyfile HLpath&"\"&mod_name&"\liblist.gam", HLpath&"\"&mod_name&"\AdminMod backup of liblist.gam"
Set in_lib = fso.OpenTextFile(HLpath&"\"&mod_name&"\liblist.gam",ForReading,False)
Set out_lib = fso.OpenTextFile("admin.tmp",ForWriting,True)

while in_lib.AtEndOfStream<>true
	line = in_lib.readline
	if instr(line,"gamedll")>0 and instr(line,"gamedll_linux") <1 then
		line ="gamedll "&chr(34)&"dlls\metamod.dll"&chr(34)
		if line<>"" and GamedllFound =false then out_lib.writeline(line)
		if GamedllFound=false then GamedllFound=true
	else 
		out_lib.writeline(line)
	end if
wend
in_lib.close
out_lib.close
fso.CopyFile "admin.tmp",HLpath&"\"&mod_name&"\liblist.gam"
fso.Deletefile "admin.tmp"
set fso=nothing
answer=msgbox("                                                Admin Mod " & version &" Files installed." & vbcrlf & vbcrlf & "Click Ok to use this script to start basic configuration, press cancel to do this manually later.",vbokcancel,"Files Installed")

if answer =1 then 
	installfiles
else
	msgbox "installation finished you should now set up your config files.",vbokonly,"Installation Completed"
end if

'----------------------------------------------------------------------------------------------------------------------------

public sub getregkey()
	on error resume next ' handle errors in _this procedure only_
	set WSHShell = CreateObject("WScript.Shell") 
	HLpath = WSHShell.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Sierra OnLine\Setup\HALFLIFE\directory")
	if HLpath ="" then WSHShell.regread("HKEY_LOCAL_MACHINE\SOFTWARE\Sierra OnLine\Setup\CSTRIKE\directory")
	if HLpath ="" then HLpath=".."
	set WSHShell=nothing
end sub

'----------------------------------------------------------------------------------------------------------------------------

public sub Installfiles()
set fso=createobject("scripting.filesystemobject")
filenamein ="config\server.cfg"
if fso.fileexists(filenamein) then
	set TSO=fso.opentextfile(filenamein)
		dim invar,invar2
		invar =tso.readall
		invar2=replace(invar,vbcrlf,vbverticaltab)
		if instr(1,invar2,vblf)>0 then
			invar2=replace(invar2,vblf,vbcrlf)
			invar=replace(invar2,vbverticaltab,vbcrlf)
		end if
	tso.close
	set tso=nothing
	filenameout=inputbox("Define the server config file that the Admin Mod variables are to be appended to. Eg listenserver.cfg for a server to be run from inside halflife or server.cfg for a dedicated server.","Server config file")
	if fso.fileexists(hlpath &"\"& mod_name &"\"& filenameout) = true then
		set tso = fso.opentextfile(hlpath &"\"& mod_name &"\"& filenameout,8,false)
		tso.write(invar)
		invar=vbnullchar
		invar2=vbnullchar
		tso.close
	else
		filenameout=inputbox("That file was not found please redefine the the server config file these values are to be appended to. Eg listenserver.cfg or server.cfg.","Server config file")
		if fso.fileexists(hlpath &"\"& mod_name &"\"& filenameout)=false then
			msgbox "File not found. this program will now exit.",vbokonly,"Exiting"
			wscript.quit 1
		end if
	end if
else
	set fso=nothing
	msgbox "The inputfile " & filenamein & " was not found." & vbcrlf & "Please make sure all files are correctly unzipped and try again.",vbokonly,"Warning"
	wscript.quit 1
end if
if fso.fileexists(hlpath &"\"& mod_name &"\config.cfg")=true then
	answer=msgbox("Do you wish to set up your username to have full access?",vbyesno,"Set up owner account")
	if answer =6 then
		makeaccess
	else
		msgbox "Admin Mod "&version&" installation completed, you should now edit/create your users.ini file and remember to create or update your adminpass.cfg file to reflect the admin password you choose to  give you access to Admin Mod functions.",vbokonly,"Installation Completed"

	end if
else 
	msgbox "Admin Mod "&version&" installation completed, you should now edit/create your users.ini file and remember to create or update your adminpass.cfg file to reflect the admin password you choose to  give you access to Admin Mod functions.",vbokonly,"Installation Completed" 
end if
end sub

'----------------------------------------------------------------------------------------------------------------------------

public sub makeaccess
set tso=fso.opentextfile(hlpath &"\"& mod_name &"\config.cfg",1,false)
do while tso.atendofstream<>true
	str=tso.readline
	if left(str,4)="name" then
		username= right(str,len(str)-5)
		if left(username,1)=chr(34) then username =right(username,len(username)-1)
		if right(username,1)=chr(34) then username =left(username,len(username)-1)
		exit do
	end if
loop
tso.close
if username="" then username=inputbox("Give your username.","username")
pass=inputbox("Give your password.","Password")
if pass="" then pass=inputbox("Give a non zero length password.","Password")
if pass="" then
	msgbox "No password defined. Exiting.",vbokonly,"Exiting"
	wscript.quit 1
end if

if fso.fileexists(hlpath &"\"& mod_name &"\adminpass.cfg") =true then
	set tso = fso.opentextfile(hlpath &"\"& mod_name &"\adminpass.cfg",8,true)
else
	set tso = fso.opentextfile(hlpath &"\"& mod_name &"\adminpass.cfg",2,true)
end if
tso.writeline vbcrlf&"// Admin Mod access command"&vbcrlf&vbcrlf&"setinfo " &chr(34) &"pw-home"&chr(34)&" "&chr(34)&pass&chr(34)
tso.close
set tso = fso.opentextfile(hlpath &"\"& mod_name &"\users.ini",8,true)
tso.writeline username&":"&pass&":65535"
tso.close
int=0
noread=0

msgbox "                                                                Admin Mod "& version&" is now minimally installed."&vbcrlf&vbcrlf&"It is greatly recommended that you read through the documentation and customize  this installation. Any problems arising when you try to run the server for the first time should all be covered in the supplied documentation, please read this carefully and only then if the problem persists visit the Admin Mod forums which can be found by following the links from www.adminmod.org.",vbokonly,"Installation Completed"
end sub

'----------------------------------------------------------------------------------------------------------------------------
private sub checkfiles
' this should check the files and folders that will be unzipped to make sure all the files needed by the installer are
' correctly placed and unzipped, i could do file size comparisons but there's no real point to that.
if fso.FolderExists("dlls")<>true then call errorexit("folder (\dlls)")
if fso.FolderExists("scripting\examples")<>true then call errorexit("folder (\scripting\examples)")
if fso.FolderExists("config")<>true then call errorexit("folder (\config)")
if fso.fileexists("dlls\metamod.dll")<> true then call errorexit("dll (\dlls\metamod.dll)")
if fso.fileexists("dlls\admin_MM.dll")<> true then call errorexit("dll (\dlls\admin_MM.dll)")
if fso.fileexists("dlls\amx_admin.dll")<> true then call errorexit("dll (\dlls\amx_admin.dll)")
if fso.fileexists("config\server.cfg")<> true then call errorexit("file (\config\server.cfg)")

if fso.FolderExists("scripting\Binaries")<>true then
	msgbox "The installer could not find an essesntial folder (\scripting\binaries). Before you install Admin Mod you must run compile_all.bat to produce the compiled scripts Admin Mod uses to provide it's funtionality. Compile_all.bat can be found in the \scripting\examples directory, please run it then execute this script again.",vbokonly,"Installation could not start"
	wscript.quit 1
end if

if fso.fileexists("scripting\binaries\plugin_base.AMX")<> true then
	msgbox "The installer could not find an essesntial file plugin_base.amx. Before you install Admin Mod you must run compile_all.bat to produce the compiled scripts Admin Mod uses to provide it's funtionality. Compile_all.bat can be found in the \scripting\examples directory, please run it then execute this script again.",vbokonly,"Installation could not start"
	wscript.quit 1
end if
end sub
'----------------------------------------------------------------------------------------------------------------------------
private sub ErrorExit(errorfile)
	msgbox "                The installer could not find an essesntial "&errorfile&"."&vbcrlf&"This is usually caused by Admin Mod being unzipped incorrectly please try again making"&vbcrlf&"               sure to maintain the directory structure. This installer will now exit.",vbokonly,"Installation could not start"
	wscript.quit 1
end sub

